Subject: Re: [PATCH v2 4/4] perf augmented_raw_syscalls: Document clang configuration

From: Arnaldo Carvalho de Melo <[email-masked]>
Date: Thu, 6 Jun 2019 15:29:41 -0300

Em Thu, Jun 06, 2019 at 10:35:32PM +0800, Leo Yan escreveu:
> On Thu, Jun 06, 2019 at 11:08:00AM -0300, Arnaldo Carvalho de Melo wrote:
> > Em Thu, Jun 06, 2019 at 05:48:45PM +0800, Leo Yan escreveu:
> > > To build this program successfully with clang, there have three
> > > compiler options need to be specified:
> > > 
> > >   - Header file path: tools/perf/include/bpf;
> > >   - Specify architecture;
> > >   - Define macro __NR_CPUS__.
> > 
> > So, this shouldn't be needed, all of this is supposed to be done
> > automagically, have you done a 'make -C tools/perf install'?
> 
> I missed the up operation.  But after git pulled the lastest code base
> from perf/core branch and used the command 'make -C tools/perf
> install', I still saw the eBPF build failure.
> 
> Just now this issue is fixed after I removed the config
> 'clang-bpf-cmd-template' from ~/.perfconfig;  the reason is I followed
> up the Documentation/perf-config.txt to set the config as below:
> 
>   clang-bpf-cmd-template = "$CLANG_EXEC -D__KERNEL__ $CLANG_OPTIONS \
>                           $KERNEL_INC_OPTIONS -Wno-unused-value \
>                           -Wno-pointer-sign -working-directory \
>                           $WORKING_DIR -c $CLANG_SOURCE -target bpf \
>                           -O2 -o -"
> 
> In fact, util/llvm-utils.c has updated the default configuration as
> below:
> 
>   #define CLANG_BPF_CMD_DEFAULT_TEMPLATE                          \
>                 "$CLANG_EXEC -D__KERNEL__ -D__NR_CPUS__=$NR_CPUS "\
>                 "-DLINUX_VERSION_CODE=$LINUX_VERSION_CODE "     \
>                 "$CLANG_OPTIONS $PERF_BPF_INC_OPTIONS $KERNEL_INC_OPTIONS " \
>                 "-Wno-unused-value -Wno-pointer-sign "          \
>                 "-working-directory $WORKING_DIR "              \
>                 "-c \"$CLANG_SOURCE\" -target bpf $CLANG_EMIT_LLVM -O2 -o - $LLVM_OPTIONS_PIPE"
> 
> Maybe should update Documentation/perf-config.txt to tell users the
> real default value of clang-bpf-cmd-template?

Sure, if you fell like doing this, please update and also please figure
out when the this changed and add a Fixes: that cset,

Its great that you're going thru the docs and making sure the
differences are noted so that we update the docs, thanks a lot!

- Arnaldo